Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 1 | """ |
| 2 | Copyright 2018-present Open Networking Foundation |
| 3 | |
| 4 | Licensed under the Apache License, Version 2.0 (the "License"); |
| 5 | you may not use this file except in compliance with the License. |
| 6 | You may obtain a copy of the License at |
| 7 | |
| 8 | http://www.apache.org/licenses/LICENSE-2.0 |
| 9 | |
| 10 | Unless required by applicable law or agreed to in writing, software |
| 11 | distributed under the License is distributed on an "AS IS" BASIS, |
| 12 | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 13 | See the License for the specific language governing permissions and |
| 14 | limitations under the License. |
| 15 | """ |
| 16 | |
| 17 | """ |
| 18 | Rules to build the Fault Management (FM) GUI app for GUI 2 |
| 19 | |
| 20 | |
| 21 | """ |
| 22 | |
Carmelo Cascone | d33d3b4 | 2019-06-18 12:12:36 -0700 | [diff] [blame] | 23 | load("//tools/build/bazel:jdk_genrule.bzl", genrule = "jdk_genrule") |
| 24 | |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 25 | COMPILE_DEPS = CORE_DEPS + JACKSON + KRYO + [ |
| 26 | "@javax_ws_rs_api//jar", |
| 27 | "@servlet_api//jar", |
| 28 | "@jetty_websocket//jar", |
| 29 | "@jetty_util//jar", |
| 30 | "@jersey_media_multipart//jar", |
| 31 | "@jersey_server//jar", |
| 32 | "//utils/rest:onlab-rest", |
| 33 | "//core/store/serializers:onos-core-serializers", |
| 34 | ] |
| 35 | |
| 36 | TEST_DEPS = TEST + [ |
| 37 | "//core/api:onos-api-tests", |
| 38 | "//drivers/default:onos-drivers-default", |
| 39 | ] |
| 40 | |
| 41 | """ |
| 42 | Files that get put at the top level of the tar ball |
| 43 | """ |
| 44 | |
| 45 | filegroup( |
| 46 | name = "_root_level_files", |
| 47 | srcs = |
| 48 | [ |
| 49 | ":angular.json", |
| 50 | ":package.json", |
| 51 | ":package-lock.json", |
| 52 | ":tsconfig.json", |
| 53 | ":tslint.json", |
| 54 | ], |
| 55 | ) |
| 56 | |
| 57 | filegroup( |
| 58 | name = "_e2e_test_files", |
| 59 | srcs = [ |
| 60 | ":e2e/protractor.conf.js", |
| 61 | ":e2e/src/app.e2e-spec.ts", |
| 62 | ":e2e/src/app.po.ts", |
| 63 | ":e2e/tsconfig.e2e.json", |
| 64 | ], |
| 65 | ) |
| 66 | |
| 67 | """ |
| 68 | Run ng build to create FM GUI 2 library in production mode |
| 69 | The output file fm-gui2-lib-ver.tgz is in the form that can be uploaded directly to https://www.npmjs.com/ |
| 70 | See bazel-genfiles/apps/faultmanagement/fm-gui2-lib/fm-gui2-lib.log for details of the Angular CLI output |
| 71 | """ |
| 72 | |
| 73 | genrule( |
| 74 | name = "fm-gui2-lib-build", |
| 75 | srcs = [ |
| 76 | "@nodejs//:bin/npm", |
| 77 | "@nodejs//:bin/node", |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 78 | "@nodejs//:bin/nodejs/bin/node", |
| 79 | "@nodejs//:bin/nodejs/bin/npm", |
| 80 | "//web/gui2-fw-lib:onos-gui2-fw-npm-install", |
| 81 | "//web/gui2-fw-lib:onos-gui2-fw-ng-build", |
| 82 | "//web/gui2-fw-lib:gui2_fw_lib_ext_css", |
| 83 | ":_root_level_files", |
| 84 | ":_fm_gui2_lib_src", |
| 85 | ":_fm-gui2_app_files", |
| 86 | ], |
| 87 | outs = [ |
| 88 | "fm-gui2-lib.log", |
| 89 | "fm-gui2-lib-ver.tgz", |
| 90 | ], |
| 91 | cmd = "ROOT=`pwd` &&" + |
| 92 | " export HOME=. &&" + |
| 93 | " export XDG_CONFIG_HOME=$(@D)/config &&" + |
| 94 | " NODE=$(location @nodejs//:bin/node) &&" + |
| 95 | " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created |
| 96 | " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created |
| 97 | " mkdir -p apps/faultmanagement/fm-gui2-lib &&" + |
| 98 | " cd apps/faultmanagement/fm-gui2-lib &&" + |
| 99 | " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" + |
| 100 | " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" + |
| 101 | " mv package/ node_modules/gui2-fw-lib/ &&" + |
| 102 | " mkdir -p projects/fm-gui2-lib/fw &&" + |
| 103 | " (cd projects/fm-gui2-lib/fw &&" + |
| 104 | " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" + |
| 105 | " chmod +x node_modules/@angular/cli/bin/ng &&" + |
| 106 | " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/apps/faultmanagement/fm-gui2-lib/node_modules/@angular/cli/bin:$$PATH &&" + |
| 107 | " ng build --prod fm-gui2-lib >> $$ROOT/$(location fm-gui2-lib.log) 2>&1 ||" + |
| 108 | " if [ $$? -eq 0 ]; then echo 'Successfully ran build';" + |
| 109 | " else " + |
| 110 | " echo 'Error running \'ng build fm-gui2-lib\' on \'//apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build\'. \\\n" + |
| 111 | " See bazel-genfiles/apps/faultmanagement/fm-gui2-lib/fm-gui2-lib.log for more details' >&2;" + |
| 112 | #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" + |
| 113 | " exit 1;" + |
| 114 | " fi;" + |
| 115 | " cd dist/fm-gui2-lib && " + |
| 116 | " npm pack >> $$ROOT/$(location fm-gui2-lib.log) 2>&1 &&" + |
| 117 | " mv fm-gui2-lib-*.tgz $$ROOT/$(location fm-gui2-lib-ver.tgz) &&" + |
| 118 | " touch $$ROOT/$(location fm-gui2-lib.log)", # to get the log always as the 2nd file, |
| 119 | message = "Angular FM GUI2 build", |
| 120 | visibility = ["//visibility:public"], |
| 121 | ) |
| 122 | |
| 123 | """ |
| 124 | Run 'ng test' to run Angular test and 'ng lint' for checkstyle |
| 125 | See bazel-genfiles/apps/faultmanagement/fm-gui2-lib/fm-gui2-lib-lint.log or |
| 126 | bazel-genfiles/apps/faultmanagement/fm-gui2-lib/fm-gui2-lib-test.log for details of the Angular CLI output |
| 127 | """ |
| 128 | |
| 129 | genrule( |
| 130 | name = "_fm-gui2-lib-test-genrule", |
| 131 | srcs = [ |
| 132 | "@nodejs//:bin/npm", |
| 133 | "@nodejs//:bin/node", |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 134 | "@nodejs//:bin/nodejs/bin/node", |
| 135 | "@nodejs//:bin/nodejs/bin/npm", |
| 136 | "//web/gui2-fw-lib:onos-gui2-fw-npm-install", |
| 137 | "//web/gui2-fw-lib:onos-gui2-fw-ng-build", |
| 138 | "//web/gui2-fw-lib:gui2_fw_lib_ext_css", |
| 139 | ":_root_level_files", |
| 140 | ":_fm_gui2_lib_src", |
| 141 | ":_fm_gui2_lib_src_tests", |
| 142 | ], |
| 143 | outs = [ |
| 144 | "fm-gui2-lib-ver.log", |
| 145 | "fm-gui2-lib-lint.log", |
| 146 | "fm-gui2-lib-test.log", |
| 147 | ], |
| 148 | cmd = " ROOT=`pwd` &&" + |
| 149 | " export HOME=. &&" + |
| 150 | " export XDG_CONFIG_HOME=$(@D)/config &&" + |
| 151 | " NODE=$(location @nodejs//:bin/node) &&" + |
| 152 | " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created |
| 153 | " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created |
| 154 | " mkdir -p apps/faultmanagement/fm-gui2-lib &&" + |
| 155 | " cd apps/faultmanagement/fm-gui2-lib &&" + |
| 156 | " jar xf ../../../$(location :_fm_gui2_lib_src_tests) &&" + |
| 157 | " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" + |
| 158 | " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" + |
| 159 | " mv package/ node_modules/gui2-fw-lib/ &&" + |
| 160 | " mkdir -p projects/fm-gui2-lib/fw &&" + |
| 161 | " (cd projects/fm-gui2-lib/fw &&" + |
| 162 | " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" + |
| 163 | " chmod +x $$ROOT/apps/faultmanagement/fm-gui2-lib/node_modules/@angular/cli/bin/ng &&" + |
| 164 | " export PATH=$$ROOT/$$(dirname $${NODE}):node_modules/@angular/cli/bin:$$PATH &&" + |
| 165 | " node -v > ../../../$(location fm-gui2-lib-ver.log) &&" + |
| 166 | " npm -v >> ../../../$(location fm-gui2-lib-ver.log) &&" + |
| 167 | " ng -v >> ../../../$(location fm-gui2-lib-ver.log) &&" + |
| 168 | " ng lint fm-gui2-lib > ../../../$(location fm-gui2-lib-lint.log);" + |
| 169 | " if [ -f /usr/bin/chromium-browser ]; then " + # Add to this for Mac and Chrome |
| 170 | " export CHROME_BIN=/usr/bin/chromium-browser; " + |
| 171 | " elif [ -f /opt/google/chrome/chrome ]; then " + |
| 172 | " export CHROME_BIN=/opt/google/chrome/chrome; " + |
| 173 | " else " + |
| 174 | " MSG='Warning: Step fm-gui2-lib-tests skipped because \\n" + |
| 175 | " no binary for ChromeHeadless browser was found at /usr/bin/chromium-browser. \\n" + |
| 176 | " Install Google Chrome or Chromium Browser to allow this step to run.';" + |
| 177 | " echo -e $$MSG >&2;" + |
| 178 | " echo -e $$MSG > ../../../$(location fm-gui2-lib-test.log);" + |
| 179 | " exit 0;" + |
| 180 | " fi;" + |
Sean Condon | 7d27516 | 2018-11-02 16:29:06 +0000 | [diff] [blame] | 181 | " ng test fm-gui2-lib --preserve-symlinks --code-coverage --browsers=ChromeHeadless" + |
| 182 | " --watch=false > ../../../$(location fm-gui2-lib-test.log) 2>&1 ||" + |
Sean Condon | 87b7850 | 2018-09-17 20:53:24 +0100 | [diff] [blame] | 183 | " if [ $$? -eq 0 ]; then echo 'Successfully ran tests';" + |
| 184 | " else " + |
| 185 | " echo 'Error running \'ng test fm-gui2-lib\' on \'//apps/faultmanagement/fm-gui2-lib:_fm-gui2-lib-test-genrule\'. \\\n" + |
| 186 | " See bazel-genfiles/apps/faultmanagement/fm-gui2-lib/fm-gui2-lib-test.log for more details' >&2;" + |
| 187 | " exit 1;" + |
| 188 | " fi;", |
| 189 | message = "Angular FM GUI2 Lib lint and test", |
| 190 | ) |
| 191 | |
| 192 | """ |
| 193 | Make a group of all the webapp files. |
| 194 | """ |
| 195 | |
| 196 | filegroup( |
| 197 | name = "_fm_gui2_lib_src", |
| 198 | srcs = glob( |
| 199 | [ |
| 200 | "projects/fm-gui2-lib/**/*", |
| 201 | ], |
| 202 | exclude = [ |
| 203 | "projects/fm-gui2-lib/**/*.spec.*", # Don't track tests here |
| 204 | "projects/fm-gui2-lib/karma.conf.js", |
| 205 | "projects/fm-gui2-lib/src/test.ts", |
| 206 | "projects/fm-gui2-lib/fw/**/*", |
| 207 | ], |
| 208 | ), |
| 209 | ) |
| 210 | |
| 211 | """ |
| 212 | Make a group of all the webapp qpp files. |
| 213 | """ |
| 214 | |
| 215 | filegroup( |
| 216 | name = "_fm-gui2_app_files", |
| 217 | srcs = glob( |
| 218 | [ |
| 219 | "src/**/*", |
| 220 | ], |
| 221 | ), |
| 222 | ) |
| 223 | |
| 224 | """ |
| 225 | Make a jar file of all the webapp test (*.spec.ts) files. |
| 226 | """ |
| 227 | |
| 228 | genrule( |
| 229 | name = "_fm_gui2_lib_src_tests", |
| 230 | srcs = glob( |
| 231 | [ |
| 232 | "projects/fm-gui2-lib/karma.conf.js", |
| 233 | "projects/fm-gui2-lib/src/test.ts", |
| 234 | "projects/fm-gui2-lib/tsconfig.spec.json", |
| 235 | "projects/fm-gui2-lib/**/*.spec.ts", |
| 236 | ], |
| 237 | exclude = [ |
| 238 | "projects/fm-gui2-lib/ng-package.json", |
| 239 | "projects/fm-gui2-lib/ng-package.prod.json", |
| 240 | "projects/fm-gui2-lib/package.json", |
| 241 | "projects/fm-gui2-lib/tsconfig.lib.json", |
| 242 | "projects/fm-gui2-lib/tslint.json", |
| 243 | "projects/fm-gui2-lib/src/public_api.ts", |
| 244 | ], |
| 245 | ), |
| 246 | outs = ["fm_gui2_lib_src_tests.jar"], |
| 247 | cmd = "cd apps/faultmanagement/fm-gui2-lib &&" + |
| 248 | " jar Mcf ../../../$@ .", |
| 249 | ) |
| 250 | |
| 251 | """ |
| 252 | Make a jar file of all the webapp test (*.spec.ts) files. |
| 253 | """ |
| 254 | |
| 255 | genrule( |
| 256 | name = "_fm_gui2_lib_tests", |
| 257 | srcs = glob( |
| 258 | [ |
| 259 | "projects/fm-gui2-lib/**/*.spec.ts", |
| 260 | "projects/fm-gui2-lib/**/*.spec.json", |
| 261 | ], |
| 262 | exclude = [ |
| 263 | "src/main/webapp/tests/**", |
| 264 | "src/main/webapp/node_modules/**", |
| 265 | "src/main/webapp/dist/**", |
| 266 | "src/main/webapp/doc/**", |
| 267 | ], |
| 268 | ), |
| 269 | outs = ["fm_gui2_lib_tests.jar"], |
| 270 | cmd = "cd apps/faultmanagement/fm-gui2-lib &&" + |
| 271 | " find projects/fm-gui2-lib/src/lib -type f -exec touch -t 201808280000 {} \; &&" + |
| 272 | " jar Mcf ../../../$@ projects/fm-gui2-lib/src/lib", |
| 273 | ) |
| 274 | |
| 275 | """ |
| 276 | Wrap the genrule for testing in a test |
| 277 | """ |
| 278 | |
| 279 | sh_test( |
| 280 | name = "fm-gui2-lib-tests", |
| 281 | size = "small", |
| 282 | srcs = [ |
| 283 | ":ng-test.sh", |
| 284 | ], |
| 285 | data = [ |
| 286 | ":_fm-gui2-lib-test-genrule", |
| 287 | ], |
| 288 | deps = [ |
| 289 | "@bazel_tools//tools/bash/runfiles", |
| 290 | ], |
| 291 | ) |